VirtualBox

source: vbox/trunk/configure@ 33524

Last change on this file since 33524 was 33515, checked in by vboxsync, 14 years ago

Configure: improve error messages

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 67.2 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2009 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, echo, grep, sed to work)
23PATH="/usr/xpg4/bin:/usr/ucb:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr [:upper:] [:lower:]`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 sunos)
55 OS='solaris'
56 ;;
57 *)
58 echo "Cannot determine OS!"
59 exit 1
60 ;;
61esac
62
63#
64# Defaults
65#
66OSE=1
67ODIR="`pwd`/"
68ODIR_OVERRIDE=0
69OUT_PATH=""
70OUT_PATH_OVERRIDE=0
71SETUP_WINE=
72TARGET_MACHINE=""
73TARGET_CPU=""
74WITH_XPCOM=1
75WITH_PYTHON=1
76WITH_JAVA=1
77WITH_VMMRAW=1
78WITH_LIBIDL=1
79WITH_GSOAP=0
80WITH_QT4=1
81WITH_SDL=1
82WITH_SDL_TTF=1
83WITH_X11=1
84WITH_ALSA=1
85WITH_PULSE=1
86WITH_DBUS=1
87WITH_KMODS=1
88WITH_OPENGL=1
89WITH_HARDENING=1
90WITH_VDE=0
91WITH_DOCS=1
92BUILD_LIBXML2=
93BUILD_LIBXSLT=
94BUILD_LIBCURL=
95BUILD_LIBSSL=
96PASSIVE_MESA=0
97CC="gcc"
98CC32=""
99CC64=""
100CXX="g++"
101CXX32=""
102CXX64=""
103BCC="bcc"
104YASM="yasm"
105IASL="iasl"
106AS86="as86"
107XSLTPROC="xsltproc"
108GENISOIMAGE="genisoimage"
109MKISOFS="mkisofs"
110INCCRYPTO=""
111LIBCRYPTO="-lcrypto"
112LIBPTHREAD="-lpthread"
113LIBCAP="-lcap"
114GSOAP=""
115GSOAP_IMPORT=""
116INCX11="/usr/local/include"
117LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
118LIBXCURSOR="-lXcursor"
119LIBXMU="-lXmu"
120LIBXINERAMA="-lXinerama"
121LIBXRANDR="-lXrandr"
122MAKESELF="makeself"
123MESA="-lGL"
124INCZ=""
125LIBZ="-lz"
126CXX_FLAGS=""
127if [ "$OS" = "freebsd" ]; then
128 INCCURL="-I/usr/local/include"
129 LIBCURL="-L/usr/local/lib -lcurl"
130 INCPULSE="-I/usr/local/include"
131 LIBPULSE="-L/usr/local/lib"
132 INCPNG="-I/usr/local/include"
133 LIBPNG="-L/usr/local/lib -lpng"
134else
135 INCCURL=""
136 LIBCURL="-lcurl"
137 INCPNG=""
138 LIBPNG="-lpng"
139fi
140PKGCONFIG="`which_wrapper pkg-config`"
141PYTHONDIR="/usr /usr/local"
142QT4DIR="/usr/lib/qt4 /usr/share/qt4 /usr/lib64/qt4 /usr /usr/local"
143QT4DIR_PKGCONFIG=1
144QT4UIC3DIR="/usr/bin"
145KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
146DEVDIR="`cd \`dirname $0\`; pwd`/tools"
147if [ -d "/lib/modules/`uname -r`/build" ]; then
148 LINUX="/lib/modules/`uname -r`/build"
149else
150 LINUX="/usr/src/linux"
151fi
152KCHMVIEWER="kchmviewer"
153LOG="configure.log"
154CNF="AutoConfig.kmk"
155ENV="env.sh"
156BUILD_TYPE="release"
157# the restricting tool is ar (mri mode).
158INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
159
160if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
161 echo "Error: VBox base path contains invalid characters!"
162 exit 1
163fi
164
165# darwin /bin/sh has a builtin echo that doesn't grok -n. gotta love it.
166if [ "$OS" = "darwin" ]; then
167 ECHO_N="/bin/echo -n"
168else
169 ECHO_N="echo -n"
170fi
171
172
173cleanup()
174{
175 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
176}
177
178fail()
179{
180 if [ -z "$nofatal" -o "x$1" != "x" ]; then
181 cleanup
182 rm -f $ENV
183 echo "Check $LOG for details"
184 exit 1
185 fi
186}
187
188log()
189{
190 echo "$1"
191 echo "$1" >> $LOG
192}
193
194log_success()
195{
196 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
197 echo "OK."
198 echo "$1" >> $LOG
199 echo >> $LOG
200 echo >> $LOG
201}
202
203log_failure()
204{
205 echo
206 echo " ** $1!"
207 echo "** $1!" >> $LOG
208 echo >> $LOG
209}
210
211cnf_append()
212{
213 printf "%-30s := %s\n" "$1" "$2" >> $CNF
214}
215
216strip_l()
217{
218 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
219}
220
221strip_L()
222{
223 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
224}
225
226strip_I()
227{
228 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
229}
230
231prefix_I()
232{
233 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
234}
235
236check_avail()
237{
238 if [ -z "$1" ]; then
239 log_failure "$2 is empty"
240 fail $3
241 return 1
242 elif which_wrapper $1 > /dev/null; then
243 return 0
244 else
245 log_failure "$1 (variable $2) not found"
246 fail $3
247 return 1
248 fi
249}
250
251
252# Prepare a test
253test_header()
254{
255 echo "***** Checking $1 *****" >> $LOG
256 $ECHO_N "Checking for $1: "
257}
258
259
260# Compile a test
261# $1 compile flags/libs
262# $2 library name
263# $3 package name
264# $4 if this argument is 'nofatal', don't abort
265test_compile()
266{
267 echo "compiling the following source file:" >> $LOG
268 cat $ODIR.tmp_src.cc >> $LOG
269 echo "using the following command line:" >> $LOG
270 echo "$CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
271 $CXX $CXX_FLAGS -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
272 if [ $? -ne 0 ]; then
273 if [ -z "$4" ]; then
274 echo
275 echo " $2 not found at $1 or $3 headers not found"
276 echo " Check the file $LOG for detailed error information."
277 fail
278 else
279 echo >> $LOG
280 echo >> $LOG
281 fi
282 return 1
283 fi
284 return 0
285}
286
287
288# Execute a compiled test binary
289test_execute()
290{
291 echo "executing the binary" >> $LOG
292 $ODIR.tmp_out > $ODIR.test_execute.log
293 rc=$?
294 cat $ODIR.test_execute.log | tee -a $LOG
295 if [ $rc -ne 0 ]; then
296 fail $1
297 return 1
298 fi
299 echo >> $LOG
300 echo >> $LOG
301 return 0
302}
303
304
305# Execute a compiled test binary
306test_execute_path()
307{
308 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
309 LD_LIBRARY_PATH=$1 $ODIR.tmp_out > $ODIR.test_execute.log
310 rc=$?
311 cat $ODIR.test_execute.log | tee -a $LOG
312 if [ $rc -ne 0 ]; then
313 fail
314 return 1
315 fi
316 echo >> $LOG
317 echo >> $LOG
318 return 0
319}
320
321
322#
323# Check for OS, MACHINE, CPU
324#
325check_environment()
326{
327 test_header environment
328 BUILD_CPU=`uname -m`
329 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
330 case "$BUILD_CPU" in
331 i[3456789]86|x86|i86pc)
332 BUILD_MACHINE='x86'
333 LIB='lib'
334 ;;
335 x86_64|amd64)
336 BUILD_MACHINE='amd64'
337 BUILD_CPU='k8'
338 if [ "$OS" != "solaris" ]; then
339 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
340 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
341 LIB='lib64'
342 else
343 # Solaris doesn't seem to subscribe to fhs, libs are usually in
344 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
345 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
346 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
347 # have to make sure the */bin/amd64 dirs are searched before the */bin
348 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
349 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
350 echo "old PATH: $PATH" >> $LOG
351 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
352 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
353 export PATH
354 echo "new PATH: $PATH" >> $LOG
355 LIB='lib/64'
356 fi
357 ;;
358 *)
359 log_failure "Cannot determine system"
360 exit 1
361 ;;
362 esac
363 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
364 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
365 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
366 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
367
368 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
369 echo "export BUILD_PLATFORM" >> $ENV
370 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
371 echo "export BUILD_PLATFORM_ARCH" >> $ENV
372 echo "BUILD_TARGET=\"$OS\"" >> $ENV
373 echo "export BUILD_TARGET" >> $ENV
374 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
375 echo "export BUILD_TARGET_ARCH" >> $ENV
376 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
377 echo "export BUILD_TARGET_CPU" >> $ENV
378 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
379 echo "export BUILD_TYPE" >> $ENV
380}
381
382#
383# Check for gcc with version >= 3.2.
384# We depend on a working gcc, if we fail terminate in every case.
385#
386check_gcc()
387{
388 test_header gcc
389 if check_avail "$CC" CC really; then
390 cc_ver=`$CC -dumpversion` 2>/dev/null
391 if [ $? -ne 0 ]; then
392 log_failure "cannot execute '$CC -dumpversion'"
393 fail really
394 fi
395 if check_avail "$CXX" CXX really; then
396 cxx_ver=`$CXX -dumpversion` 2>/dev/null
397 if [ $? -ne 0 ]; then
398 log_failure "cannot execute '$CXX -dumpversion'"
399 fail really
400 fi
401 cc_maj=`echo $cc_ver|cut -d. -f1`
402 cc_min=`echo $cc_ver|cut -d. -f2`
403 if [ "x$cc_ver" != "x$cxx_ver" ]; then
404 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
405 fail really
406 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
407 log_success "found version $cc_ver"
408 # gcc-4.0 is allowed for Darwin only
409 elif [ $cc_maj -lt 3 \
410 -o \( $cc_maj -eq 3 -a $cc_min -lt 2 \) \
411 -o \( $cc_maj -eq 4 -a $cc_min -lt 1 -a "$OS" != "darwin" \) \
412 -o \( $cc_maj -eq 4 -a $cc_min -gt 5 \) \
413 -o $cc_maj -gt 4 ]; then
414 log_failure "gcc version $cc_ver found, expected gcc 3.x with x>1 or gcc 4.x with 0<x<5"
415 fail really
416 else
417 log_success "found version $cc_ver"
418 fi
419 if [ "$BUILD_MACHINE" = "amd64" ]; then
420 [ -z "$CC32" ] && CC32="$CC -m32"
421 [ -z "$CXX32" ] && CXX32="$CXX -m32"
422 else
423 [ -z "$CC32" ] && CC32="$CC"
424 [ -z "$CXX32" ] && CXX32="$CXX"
425 fi
426 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
427 [ -z "$CC64" ] && CC64="$CC -m64"
428 [ -z "$CXX64" ] && CXX64="$CXX -m64"
429 fi
430 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
431 CC32="undefined"
432 CXX32="undefined"
433 fi
434 if [ "$CC" != "gcc" ]; then
435 cnf_append "TOOL_GCC3_CC" "$CC"
436 cnf_append "TOOL_GCC3_AS" "$CC"
437 cnf_append "TOOL_GCC3_LD" "$CC"
438 cnf_append "TOOL_GXX3_CC" "$CC"
439 cnf_append "TOOL_GXX3_AS" "$CC"
440 fi
441 if [ "$CXX" != "g++" ]; then
442 cnf_append "TOOL_GCC3_CXX" "$CXX"
443 cnf_append "TOOL_GXX3_CXX" "$CXX"
444 cnf_append "TOOL_GXX3_LD" "$CXX"
445 fi
446 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
447 cnf_append "TOOL_GCC32_CC" "$CC32"
448 cnf_append "TOOL_GCC32_AS" "$CC32"
449 cnf_append "TOOL_GCC32_LD" "$CC32"
450 cnf_append "TOOL_GXX32_CC" "$CC32"
451 cnf_append "TOOL_GXX32_AS" "$CC32"
452 fi
453 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
454 cnf_append "TOOL_GCC32_CXX" "$CXX32"
455 cnf_append "TOOL_GXX32_CXX" "$CXX32"
456 cnf_append "TOOL_GXX32_LD" "$CXX32"
457 fi
458 # this isn't not necessary, there is not such tool.
459 if [ -n "$CC64" ]; then
460 cnf_append "TOOL_GCC64_CC" "$CC64"
461 cnf_append "TOOL_GCC64_AS" "$CC64"
462 cnf_append "TOOL_GCC64_LD" "$CC64"
463 cnf_append "TOOL_GXX64_CC" "$CC64"
464 cnf_append "TOOL_GXX64_AS" "$CC64"
465 fi
466 if [ -n "$CXX64" ]; then
467 cnf_append "TOOL_GCC64_CXX" "$CXX64"
468 cnf_append "TOOL_GXX64_CXX" "$CXX64"
469 cnf_append "TOOL_GXX64_LD" "$CXX64"
470 fi
471 # Solaris sports a 32-bit gcc/g++.
472 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
473 [ "$CC" = "gcc" ] && CC="gcc -m64"
474 [ "$CXX" = "g++" ] && CXX="g++ -m64"
475 fi
476 fi
477 fi
478}
479
480
481#
482# Check for the bcc compiler, needed for compiling the BIOS
483#
484check_bcc()
485{
486 test_header bcc
487 if check_avail "$BCC" BCC; then
488 bcc_ver=`$BCC -v 2>&1|grep version|sed 's+^bcc: version \(.*\)+\1+'`
489 if [ $? -ne 0 ]; then
490 log_failure "BCC not found"
491 fail
492 else
493 echo "compiling the following source file:" >> $LOG
494 cat > $ODIR.tmp_src.c << EOF
495int foo(a)
496 int a;
497{
498 return 0;
499}
500EOF
501 cat $ODIR.tmp_src.c >> $LOG
502 bcc_path=`which_wrapper $BCC`
503 bcc_dir="`dirname $bcc_path`/"
504 echo "using the following command line:" >> $LOG
505 echo "$BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
506 $BCC -B $bcc_dir -C-c -3 -S -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
507 if [ $? -ne 0 ]; then
508 log_failure "BCC not working"
509 fail
510 else
511 log_success "found version $bcc_ver"
512 cnf_append "VBOX_BCC" "$bcc_path -B $bcc_dir"
513 fi
514 unset bcc_path
515 unset bcc_dir
516 fi
517 fi
518}
519
520
521#
522# Check for the as86 assembler, needed for compiling the BIOS
523#
524check_as86()
525{
526 test_header as86
527 if check_avail "$AS86" AS86; then
528 as86_ver=`$AS86 -v 2>&1|grep version|sed 's+^as86 version: \(.*\)+\1+'`
529 if [ $? -ne 0 ]; then
530 log_failure "as86 not found"
531 fail
532 else
533 log_success "found version $as86_ver"
534 cnf_append "VBOX_AS86" "`which_wrapper $AS86`"
535 fi
536 fi
537}
538
539
540#
541# Check for yasm, needed to compile assembler files
542#
543check_yasm()
544{
545 test_header yasm
546 if check_avail "$YASM" YASM; then
547 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
548 if [ $? -ne 0 ]; then
549 log_failure "yasm not found"
550 fail
551 else
552 yasm_maj=`echo $yasm_ver|cut -d. -f1`
553 yasm_min=`echo $yasm_ver|cut -d. -f2`
554 yasm_rev=`echo $yasm_ver|cut -d. -f3`
555 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
556 if [ $yasm_ver_mul -lt 501 ]; then
557 log_failure "found version $yasm_ver, expected at least 0.5.1"
558 fail
559 else
560 log_success "found version $yasm_ver"
561 fi
562 fi
563 fi
564}
565
566
567#
568# Check for the iasl ACPI compiler, needed to compile vbox.dsl
569#
570check_iasl()
571{
572 test_header iasl
573 if check_avail "$IASL" IASL; then
574 iasl_ver=`$IASL|grep version|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
575 if [ $? -ne 0 ]; then
576 log_failure "iasl not found"
577 fail
578 else
579 log_success "found version $iasl_ver"
580 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
581 fi
582 fi
583}
584
585
586#
587# Check for xsltproc, needed by Main
588#
589check_xsltproc()
590{
591 test_header xslt
592 if check_avail "$XSLTPROC" XSLTPROC; then
593 xsltproc_ver=`$XSLTPROC --version`
594 if [ $? -ne 0 ]; then
595 log_failure "xsltproc not found"
596 fail
597 else
598 log_success "found"
599 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
600 fi
601 fi
602}
603
604
605#
606# Check for mkisofs, needed to build the CDROM image containing the additions
607#
608check_mkisofs()
609{
610 test_header mkisofs
611 if which_wrapper $GENISOIMAGE > /dev/null; then
612 mkisofs_ver=`$GENISOIMAGE --version`
613 if [ $? -ne 0 ]; then
614 log_failure "mkisofs not found"
615 fail
616 else
617 log_success "found $mkisofs_ver"
618 cnf_append "VBOX_MKISOFS" "`which_wrapper $GENISOIMAGE`"
619 fi
620 elif check_avail "$MKISOFS" MKISOFS; then
621 mkisofs_ver=`$MKISOFS --version`
622 if [ $? -ne 0 ]; then
623 log_failure "mkisofs not working"
624 fail
625 else
626 log_success "found $mkisofs_ver"
627 cnf_append "VBOX_MKISOFS" "`which_wrapper $MKISOFS`"
628 fi
629 fi
630}
631
632
633#
634# Check for libxml2, needed by VBoxSettings and Runtime.
635# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
636#
637check_libxml2()
638{
639 if [ -z "$BUILD_LIBXML2" ]; then
640 test_header libxml2
641 if which_wrapper pkg-config > /dev/null; then
642 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
643 if [ $? -ne 0 ]; then
644 log_failure "libxml2 not found"
645 fail
646 else
647 FLGXML2=`pkg-config libxml-2.0 --cflags`
648 INCXML2=`strip_I "$FLGXML2"`
649 LIBXML2=`pkg-config libxml-2.0 --libs`
650 cat > $ODIR.tmp_src.cc << EOF
651#include <cstdio>
652#include <libxml/xmlversion.h>
653extern "C" int main(void)
654{
655 printf("found version %s", LIBXML_DOTTED_VERSION);
656#if LIBXML_VERSION >= 20626
657 printf(", OK.\n");
658 return 0;
659#else
660 printf(", expected version 2.6.26 or higher\n");
661 return 1;
662#endif
663}
664EOF
665 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
666 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
667 if test_execute; then
668 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
669 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
670 fi
671 fi
672 fi
673 elif which_wrapper xml2-config; then
674 libxml2_ver=`xml2-config --version`
675 if [ $? -ne 0 ]; then
676 log_failure "xml2-config not found"
677 fail
678 else
679 log_success "found version $libxml2_ver"
680 FLGXML2=`xml2-config --cflags`
681 INCXML2=`strip_I "$FLGXML2"`
682 LIBXML2=`xml2-config --libs`
683 cat > $ODIR.tmp_src.cc << EOF
684#include <cstdio>
685#include <libxml/xmlversion.h>
686extern "C" int main(void)
687{
688 printf("found version %s", LIBXML_DOTTED_VERSION);
689#if LIBXML_VERSION >= 20626
690 printf(", OK.\n");
691 return 0;
692#else
693 printf(", expected version 2.6.26 or higher\n");
694 return 1;
695#endif
696}
697EOF
698 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
699 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
700 if test_execute; then
701 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
702 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
703 fi
704 fi
705 fi
706 else
707 log_failure "neither pkg-config nor xml2-config found"
708 fail
709 fi
710 fi
711}
712
713
714#
715# Check for libxslt, needed by VBoxSettings. For now we depend on 1.1.15,
716# as Solaris right now has no newer version and it definitely works.
717# 1.1.17 is available on Ubuntu Edgy which fulfils the minimal libxml2
718# requirement (2.6.26).
719#
720check_libxslt()
721{
722 if [ -z "$BUILD_LIBXSLT" ]; then
723 test_header libxslt
724 if which_wrapper pkg-config > /dev/null; then
725 libxslt_ver=`pkg-config libxslt --modversion 2>> $LOG`
726 if [ $? -ne 0 ]; then
727 log_failure "libxslt not found"
728 fail
729 else
730 FLGXSLT=`pkg-config libxslt --cflags`
731 INCXSLT=`strip_I "$FLGXSLT"`
732 LIBXSLT=`pkg-config libxslt --libs`
733 cat > $ODIR.tmp_src.cc << EOF
734#include <cstdio>
735#include <libxslt/xsltconfig.h>
736extern "C" int main(void)
737{
738 printf("found version %s", LIBXSLT_DOTTED_VERSION);
739#if LIBXSLT_VERSION >= 10117
740 printf(", OK.\n");
741 return 0;
742#else
743 printf(", expected version 1.1.17 or higher\n");
744 return 1;
745#endif
746}
747EOF
748 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
749 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
750 if test_execute; then
751 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
752 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
753 fi
754 fi
755 fi
756 elif which_wrapper xslt-config; then
757 libxslt_ver=`xslt-config --version`
758 if [ $? -ne 0 ]; then
759 log_failure "xslt-config not working"
760 fail
761 else
762 log_success "found version $libxslt_ver"
763 FLGXSLT=`xslt-config --cflags`
764 INCXSLT=`strip_I "$FLGXSLT"`
765 LIBXSLT=`xslt-config --libs`
766 cat > $ODIR.tmp_src.cc << EOF
767#include <cstdio>
768#include <libxslt/xsltconfig.h>
769extern "C" int main(void)
770{
771 printf("found version %s", LIBXSLT_DOTTED_VERSION);
772#if LIBXSLT_VERSION >= 10117
773 printf(", OK.\n");
774 return 0;
775#else
776 printf(", expected version 1.1.17 or higher\n");
777 return 1;
778#endif
779}
780EOF
781 [ -n "$INCXSLT" ] && I_INCXSLT=`prefix_I "$INCXSLT"`
782 if test_compile "$LIBXSLT $LIBPTHREAD $I_INCXSLT" xslt xslt; then
783 if test_execute; then
784 cnf_append "SDK_VBOX_LIBXSLT_INCS" "$INCXSLT"
785 cnf_append "SDK_VBOX_LIBXSLT_LIBS" "`strip_l "$LIBXSLT"`"
786 fi
787 fi
788 fi
789 else
790 log_failure "neither pkg-config nor xslt-config found"
791 fail
792 fi
793 fi
794}
795
796
797#
798# Check for libIDL, needed by xpcom
799#
800check_libidl()
801{
802 test_header libIDL
803
804 if which_wrapper libIDL-config-2 > /dev/null; then
805 libidl_ver=`libIDL-config-2 --version`
806 if [ $? -ne 0 ]; then
807 log_failure "libIDL-config-2 not working"
808 fail
809 else
810 log_success "found version $libidl_ver"
811 cnf_append "VBOX_LIBIDL_CONFIG" \
812 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
813 fi
814 elif check_avail "libIDL-config" libIDL-config; then
815 libidl_ver=`libIDL-config --version`
816 if [ $? -ne 0 ]; then
817 log_failure "libIDL-config not working"
818 fail
819 else
820 log_success "found version $libidl_ver"
821 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
822 fi
823 fi
824}
825
826
827#
828# Check for openssl, needed for RDP and S3
829#
830check_ssl()
831{
832 if [ -z "$BUILD_LIBSSL" ]; then
833 test_header ssl
834 cat > $ODIR.tmp_src.cc << EOF
835#include <cstdio>
836#include <openssl/opensslv.h>
837extern "C" int main(void)
838{
839 printf("found version %s", OPENSSL_VERSION_TEXT);
840#if OPENSSL_VERSION_NUMBER >= 0x00908000
841 printf(", OK.\n");
842 return 0;
843#else
844 printf(", expected version 0.9.8 or higher\n");
845 return 1;
846#endif
847}
848EOF
849 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
850 if test_execute nofatal; then
851 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
852 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
853 fi
854 fi
855 fi
856}
857
858
859#
860# Check for pthread, needed by VBoxSVC, frontends, ...
861#
862check_pthread()
863{
864 test_header pthread
865 cat > $ODIR.tmp_src.cc << EOF
866#include <cstdio>
867#include <pthread.h>
868extern "C" int main(void)
869{
870 pthread_mutex_t mutex;
871 if (pthread_mutex_init(&mutex, NULL)) {
872 printf("pthread_mutex_init() failed\n");
873 return 1;
874 }
875 if (pthread_mutex_lock(&mutex)) {
876 printf("pthread_mutex_lock() failed\n");
877 return 1;
878 }
879 if (pthread_mutex_unlock(&mutex)) {
880 printf("pthread_mutex_unlock() failed\n");
881 return 1;
882 }
883 printf("found, OK.\n");
884}
885EOF
886 if test_compile $LIBPTHREAD pthread pthread; then
887 if test_execute; then
888 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
889 fi
890 fi
891}
892
893
894#
895# Check for zlib, needed by VBoxSVC, Runtime, ...
896#
897check_z()
898{
899 test_header zlib
900 cat > $ODIR.tmp_src.cc << EOF
901#include <cstdio>
902#include <zlib.h>
903extern "C" int main(void)
904{
905 printf("found version %s", ZLIB_VERSION);
906#if ZLIB_VERNUM >= 0x1210
907 printf(", OK.\n");
908 return 0;
909#else
910 printf(", expected version 1.2.1 or higher\n");
911 return 1;
912#endif
913}
914EOF
915 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
916 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
917 if test_execute; then
918 echo "if1of (\$(KBUILD_TARGET),darwin freebsd linux solaris)" >> $CNF
919 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
920 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
921 echo "endif" >> $CNF
922 fi
923 fi
924}
925
926
927#
928# Check for libpng, needed by kchmviewer
929#
930check_png()
931{
932 test_header libpng
933 cat > $ODIR.tmp_src.cc << EOF
934#include <cstdio>
935#include <png.h>
936extern "C" int main(void)
937{
938 printf("found version %s", PNG_LIBPNG_VER_STRING);
939#if PNG_LIBPNG_VER >= 10205
940 printf(", OK.\n");
941 return 0;
942#else
943 printf(", expected version 1.2.5 or higher\n");
944 return 1;
945#endif
946}
947EOF
948 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
949 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
950 if test_execute; then
951 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
952 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
953 fi
954 fi
955}
956
957#
958# Check for libcurl, needed by S3
959#
960check_curl()
961{
962 if [ -z "$BUILD_LIBCURL" ]; then
963 test_header libcurl
964 cat > $ODIR.tmp_src.cc << EOF
965#include <cstdio>
966#include <curl/curl.h>
967extern "C" int main(void)
968{
969 printf("found version %s", LIBCURL_VERSION);
970#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71601
971 printf(", OK.\n");
972 return 0;
973#else
974 printf(", expected version 7.16.1 or higher\n");
975 return 1;
976#endif
977}
978EOF
979 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
980 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
981 if test_execute; then
982 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
983 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
984 fi
985 fi
986 fi
987}
988
989
990#
991# Check for pam, needed by VRDPAuth
992# Version 79 was introduced in 9/2005, do we support older versions?
993# Debian/sarge uses 76
994# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
995#
996check_pam()
997{
998 test_header pam
999 cat > $ODIR.tmp_src.cc << EOF
1000#include <cstdio>
1001#include <security/pam_appl.h>
1002extern "C" int main(void)
1003{
1004 printf("found version %d", __LIBPAM_VERSION);
1005 if (__LIBPAM_VERSION >= 76)
1006 {
1007 printf(", OK.\n");
1008 return 0;
1009 }
1010 else
1011 {
1012 printf(", expected version 76 or higher\n");
1013 return 1;
1014 }
1015}
1016EOF
1017 if test_compile "-lpam" pam pam nofatal; then
1018 if test_execute nofatal; then
1019 return 0;
1020 fi
1021 fi
1022 echo "pam0.x not found"
1023 test_header linux_pam
1024 cat > $ODIR.tmp_src.cc << EOF
1025#include <cstdio>
1026#include <security/pam_appl.h>
1027extern "C" int main(void)
1028{
1029 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1030 if (__LINUX_PAM__ >= 1)
1031 {
1032 printf(", OK.\n");
1033 return 0;
1034 }
1035 else
1036 {
1037 printf(", expected version 1.0 or higher\n");
1038 return 1;
1039 }
1040}
1041EOF
1042 if test_compile "-lpam" pam pam; then
1043 test_execute
1044 fi
1045}
1046
1047
1048#
1049# Check for the SDL library, needed by VBoxSDL and VirtualBox
1050# We depend at least on version 1.2.7
1051#
1052check_sdl()
1053{
1054 test_header SDL
1055 if [ "$OS" = "darwin" ]; then
1056 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1057 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1058 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1059 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1060 fi
1061 if [ -n "$PATH_SDK_LIBSDL" ]; then
1062 foundsdl=1
1063 INCSDL="$PATH_SDK_LIBSDL/Headers"
1064 FLDSDL="-framework SDL"
1065 else
1066 log_failure "SDL framework not found"
1067 fail
1068 fi
1069 else
1070 if which_wrapper sdl-config > /dev/null; then
1071 FLGSDL=`sdl-config --cflags`
1072 INCSDL=`strip_I "$FLGSDL"`
1073 LIBSDL=`sdl-config --libs`
1074 LIBSDLMAIN="-lSDLmain"
1075 FLDSDL=
1076 foundsdl=1
1077 fi
1078 fi
1079 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1080 if [ -n "$foundsdl" ]; then
1081 cat > $ODIR.tmp_src.cc << EOF
1082#include <cstdio>
1083#include <SDL.h>
1084#include <SDL_main.h>
1085#undef main
1086extern "C" int main(int argc, char** argv)
1087{
1088 printf("found version %d.%d.%d",
1089 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1090#if SDL_VERSION_ATLEAST(1,2,7)
1091 printf(", OK.\n");
1092 return 0;
1093#else
1094 printf(", expected version 1.2.7 or higher\n");
1095 return 1;
1096#endif
1097}
1098EOF
1099 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1100 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1101 if test_execute; then
1102 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1103 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1104 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1105 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1106 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1107 fi
1108 fi
1109 else
1110 log_failure "SDL not found"
1111 fail
1112 fi
1113}
1114
1115
1116#
1117# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1118#
1119check_sdl_ttf()
1120{
1121 test_header SDL_ttf
1122 cat > $ODIR.tmp_src.cc << EOF
1123#include <cstdio>
1124#include <SDL_ttf.h>
1125#ifndef SDL_TTF_MAJOR_VERSION
1126#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1127#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1128#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1129#endif
1130extern "C" int main(void)
1131{
1132 printf("found version %d.%d.%d",
1133 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1134#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1135 printf(", OK.\n");
1136 return 0;
1137#else
1138 printf(", expected version 2.0.6 or higher\n");
1139 return 1;
1140#endif
1141}
1142EOF
1143 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1144 if ! test_execute nofatal; then
1145 cnf_append "VBOX_WITH_SECURELABEL" ""
1146 fi
1147 else
1148 echo "not found -- disabling VBoxSDL secure label."
1149 cnf_append "VBOX_WITH_SECURELABEL" ""
1150 fi
1151}
1152
1153
1154#
1155# Check for libasound, needed by the ALSA audio backend
1156#
1157check_alsa()
1158{
1159 test_header ALSA
1160 cat > $ODIR.tmp_src.cc << EOF
1161#include <cstdio>
1162#include <alsa/asoundlib.h>
1163extern "C" int main(void)
1164{
1165 printf("found version %d.%d.%d",
1166 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1167#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10006
1168 printf(", OK.\n");
1169 return 0;
1170#else
1171 printf(", expected version 1.0.6 or higher\n");
1172 return 1;
1173#endif
1174}
1175EOF
1176 if test_compile "-lasound" asound asound; then
1177 test_execute
1178 fi
1179}
1180
1181
1182#
1183# Check for PulseAudio
1184#
1185check_pulse()
1186{
1187 test_header "PulseAudio"
1188 cat > $ODIR.tmp_src.cc << EOF
1189#include <cstdio>
1190#include <pulse/version.h>
1191extern "C" int main(void)
1192{
1193 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1194#if PA_API_VERSION >= 9
1195 printf(", OK.\n");
1196 return 0;
1197#else
1198 printf(", expected version 0.9.0 (API version 9) or higher\n");
1199 return 1;
1200#endif
1201}
1202EOF
1203 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse; then
1204 test_execute
1205 fi
1206}
1207
1208
1209#
1210# Check for the X libraries (Xext, X11)
1211#
1212check_x()
1213{
1214 test_header "X libraries"
1215 cat > $ODIR.tmp_src.cc << EOF
1216#include <cstdio>
1217#include <X11/Xlib.h>
1218extern "C" int main(void)
1219{
1220 Display *dpy;
1221 int scrn_num;
1222 Screen *scrn;
1223 Window win;
1224
1225 dpy = XOpenDisplay(NULL);
1226 scrn_num = DefaultScreen(dpy);
1227 scrn = ScreenOfDisplay(dpy, scrn_num);
1228 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1229 0, 16, InputOutput, CopyFromParent, 0, NULL);
1230 XDestroyWindow(dpy, win);
1231 XCloseDisplay(dpy);
1232}
1233EOF
1234 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1235 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1236 log_success "found"
1237 fi
1238}
1239
1240
1241#
1242# Check for the Xcursor library, needed by VBoxSDL and VBoxBFE
1243#
1244check_xcursor()
1245{
1246 test_header Xcursor
1247 cat > $ODIR.tmp_src.cc << EOF
1248#include <cstdio>
1249#include <X11/Xlib.h>
1250#include <X11/Xcursor/Xcursor.h>
1251extern "C" int main(void)
1252{
1253 XcursorImage *cursor = XcursorImageCreate (10, 10);
1254 XcursorImageDestroy(cursor);
1255 return 0;
1256}
1257EOF
1258 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1259 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1260 log_success "found"
1261 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1262 fi
1263}
1264
1265
1266#
1267# Check for the Xinerama library, needed by the Qt GUI
1268#
1269check_xinerama()
1270{
1271 test_header Xinerama
1272 cat > $ODIR.tmp_src.cc << EOF
1273#include <X11/Xlib.h>
1274#include <X11/extensions/Xinerama.h>
1275extern "C" int main(void)
1276{
1277 Display *dpy;
1278 Bool flag;
1279 dpy = XOpenDisplay(NULL);
1280 if (dpy)
1281 {
1282 flag = XineramaIsActive(dpy);
1283 XCloseDisplay(dpy);
1284 }
1285}
1286EOF
1287 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1288 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1289 log_success "found"
1290 fi
1291}
1292
1293
1294#
1295# Check for the Xinerama library, needed by the Qt GUI
1296#
1297check_xrandr()
1298{
1299 test_header Xrandr
1300 cat > $ODIR.tmp_src.cc << EOF
1301#include <X11/Xlib.h>
1302#include <X11/extensions/Xrandr.h>
1303extern "C" int main(void)
1304{
1305 Display *dpy;
1306 Bool flag;
1307 int major, minor;
1308 dpy = XOpenDisplay(NULL);
1309 if (dpy)
1310 {
1311 flag = XRRQueryVersion(dpy, &major, &minor);
1312 XCloseDisplay(dpy);
1313 }
1314}
1315EOF
1316 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1317 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1318 log_success "found"
1319 fi
1320}
1321
1322
1323#
1324# Check for OpenGL
1325#
1326check_opengl()
1327{
1328 # On darwin this is a on/off decision only
1329 if [ "$OS" = "darwin" ]; then
1330 test_header "OpenGL support"
1331 echo "enabled"
1332 cnf_append "VBOX_WITH_CROGL" "1"
1333 else
1334 check_xmu
1335 check_mesa
1336 fi
1337}
1338
1339
1340#
1341# Check for the Xmu library, needed by OpenGL
1342#
1343check_xmu()
1344{
1345 test_header Xmu
1346 cat > $ODIR.tmp_src.cc << EOF
1347#include <cstdio>
1348#include <X11/Xatom.h>
1349#include <X11/Xlib.h>
1350#include <X11/Xutil.h>
1351#include <X11/Xmu/StdCmap.h>
1352extern "C" int main(void)
1353{
1354 Display *dpy;
1355 int scrn_num;
1356 Screen *scrn;
1357
1358 dpy = XOpenDisplay(NULL);
1359 if (dpy)
1360 {
1361 scrn_num = DefaultScreen(dpy);
1362 scrn = ScreenOfDisplay(dpy, scrn_num);
1363 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1364 24, XA_RGB_DEFAULT_MAP, False, True);
1365 printf("Status = %x\n", status);
1366 XCloseDisplay(dpy);
1367 }
1368 return 0;
1369}
1370EOF
1371 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1372 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1373 log_success "found"
1374 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1375 fi
1376}
1377
1378#
1379# Check for Mesa, needed by OpenGL
1380#
1381check_mesa()
1382{
1383 test_header "Mesa / GLU"
1384 cat > $ODIR.tmp_src.cc << EOF
1385#include <cstdio>
1386#include <X11/Xlib.h>
1387#include <GL/glx.h>
1388#include <GL/glu.h>
1389extern "C" int main(void)
1390{
1391 Display *dpy;
1392 int major, minor;
1393
1394 dpy = XOpenDisplay(NULL);
1395 if (dpy)
1396 {
1397 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1398 XCloseDisplay(dpy);
1399 if (glx_version)
1400 {
1401 printf("found version %u.%u, OK.\n", major, minor);
1402 return 0;
1403 }
1404 }
1405 printf("found (inactive), OK.\n");
1406 return 0;
1407}
1408EOF
1409 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1410 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1411 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1412 test_execute
1413 fi
1414}
1415
1416
1417#
1418# Check for the Qt4 library, needed by the VirtualBox frontend
1419#
1420# Currently not fatal.
1421#
1422check_qt4()
1423{
1424 foundqt4=
1425 test_header Qt4
1426 if [ "$OS" = "darwin" ]; then
1427 # First check if there is the internal version of Qt. If yes nothing else
1428 # has to be done.
1429 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1430 for t in $QT_INTERNAL; do
1431 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1432 cnf_append "VBOX_WITH_QT4_SUN" "1"
1433 log_success "use internal version"
1434 return
1435 fi
1436 done
1437 # Now try the user provided directory and some of the standard directories.
1438 QT_TRIES="$QT4DIR /System/Library /Library"
1439 for t in $QT_TRIES; do
1440 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1441 PATH_SDK_QT4="$t"
1442 break
1443 fi
1444 done
1445 # Add the necessary params for building the test application
1446 if [ -n "$PATH_SDK_QT4" ]; then
1447 foundqt4=1
1448 INCQT4=-I$PATH_SDK_QT4/Frameworks/QtCore.framework/Headers
1449 LIBQT4=-F$PATH_SDK_QT4/Frameworks
1450 FLGQT4="-framework QtCore"
1451 else
1452 log_failure "Qt4 framework not found (can be disabled using --disable-qt4)"
1453 fail
1454 fi
1455 else
1456 if [ $QT4DIR_PKGCONFIG -eq 1 ]; then
1457 # default is to use pkg-config
1458 if which_wrapper pkg-config > /dev/null; then
1459 # this braindead path is necessary for mdv2008.1
1460 qt4_ver=`\
1461 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1462 pkg-config QtCore --modversion 2>> $LOG`
1463 if [ $? -ne 0 ]; then
1464 log_failure "QtCore not found"
1465 fail
1466 else
1467 FLGQT4=`\
1468 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1469 pkg-config QtCore --cflags`
1470 INCQT4=`strip_I "$FLGQT4"`
1471 LIBQT4=`\
1472 PKG_CONFIG_PATH=/usr/lib/qt4/lib/pkgconfig \
1473 PKG_CONFIG_ALLOW_SYSTEM_LIBS=1 \
1474 pkg-config QtCore --libs`
1475 foundqt4=1
1476 fi
1477 else
1478 log_failure "pkg-config not found"
1479 fail
1480 fi
1481 else
1482 # do it the old way (e.g. user has specified QT4DIR)
1483 cat > $ODIR.tmp_src.cc << EOF
1484#include <cstdio>
1485#include <QtGlobal>
1486extern "C" int main(void)
1487{
1488 printf("found version %s", QT_VERSION_STR);
1489#if QT_VERSION >= 0x040400
1490 printf(", OK.\n");
1491 return 0;
1492#else
1493 printf(", expected version 4.4.0 or higher\n");
1494 return 1;
1495#endif
1496}
1497EOF
1498 for q in $QT4DIR; do
1499 INCQT4="$q/include $q/include/QtCore"
1500 FLGQT4="-DQT_SHARED"
1501 I_INCQT4=`prefix_I "$INCQT4"`
1502 LIBQT4="-L$q/lib -lQtCoreVBox"
1503 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1504 foundqt4=2
1505 break;
1506 fi
1507 LIBQT4="-L$q/lib -lQtCore"
1508 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1509 foundqt4=1
1510 break;
1511 fi
1512 done
1513 fi
1514 fi
1515 if [ -n "$foundqt4" ]; then
1516 cat > $ODIR.tmp_src.cc << EOF
1517#include <cstdio>
1518#include <QtGlobal>
1519extern "C" int main(void)
1520{
1521 printf("found version %s", QT_VERSION_STR);
1522#if QT_VERSION >= 0x040400
1523 printf(", OK.\n");
1524 return 0;
1525#else
1526 printf(", expected version 4.4.0 or higher\n");
1527 return 1;
1528#endif
1529}
1530EOF
1531 [ -n "$INCQT4" ] && I_INCQT4=`prefix_I "$INCQT4"`
1532 if test_compile "$LIBQT4 $LIBPTHREAD $I_INCQT4 $FLGQT4" qt4 qt4 nofatal; then
1533 if test_execute_path "`strip_L "$LIBQT4"`"; then
1534 if [ "$OS" = "darwin" ]; then
1535 # Successful build & run the test application so add the necessary
1536 # params to AutoConfig.kmk
1537 cnf_append "PATH_SDK_QT4_INC" "$PATH_SDK_QT4/Frameworks"
1538 cnf_append "PATH_SDK_QT4_LIB" "$PATH_SDK_QT4/Frameworks"
1539 cnf_append "PATH_SDK_QT4" "$PATH_SDK_QT4/Frameworks"
1540 # Check for the moc tool in the Qt directory found & some standard
1541 # directories.
1542 for q in $PATH_SDK_QT4 /usr /Developer/Tools/Qt; do
1543 if which_wrapper "$q/bin/moc" > /dev/null; then
1544 cnf_append "PATH_TOOL_QT4" "$q"
1545 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1546 fi
1547 done
1548 else
1549 # strip .../QtCore as we add components ourself
1550 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1551 # store only the first path, remove all other pathes
1552 # most likely pkg-config gave us -I/usr/include/qt4 -I/usr/include/qt4/QtCore
1553 INCQT4=`echo "$INCQT4"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1554 cnf_append "VBOX_PATH_QT4_LIB" "`strip_L "$LIBQT4"`"
1555 cnf_append "SDK_QT4_LIBPATH" "`strip_L "$LIBQT4"`"
1556 cnf_append "PATH_SDK_QT4_INC" "$INCQT4"
1557 # this is not quite right since the qt libpath does not have to be first...
1558 cnf_append "PATH_SDK_QT4_LIB" '$'"(firstword `strip_L "$LIBQT4"`)"
1559 if [ "$foundqt4" = "2" ]; then
1560 cnf_append "VBOX_WITH_QT4_SUN" "1"
1561 fi
1562 test_header "Qt4 devtools"
1563 for q in $QT4DIR; do
1564 # first try it with a suffix, some platforms use that
1565 if which_wrapper "$q/bin/moc-qt4" > /dev/null; then
1566 moc_ver=`$q/bin/moc-qt4 -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1567 if [ $? -ne 0 ]; then
1568 log_failure "moc-qt4 not working"
1569 fail
1570 else
1571 log_success "found version $moc_ver"
1572 cnf_append "VBOX_PATH_QT4" "$q"
1573 cnf_append "PATH_SDK_QT4" "$q"
1574 cnf_append "PATH_TOOL_QT4" "$q"
1575 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1576 cnf_append "TOOL_QT4_BIN_SUFF" "-qt4"
1577 return
1578 fi
1579 elif which_wrapper "$q/bin/moc" > /dev/null; then
1580 moc_ver=`$q/bin/moc -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1581 if [ $? -ne 0 ]; then
1582 log_failure "moc not working"
1583 fail
1584 else
1585 log_success "found version $moc_ver"
1586 cnf_append "VBOX_PATH_QT4" "$q"
1587 cnf_append "PATH_SDK_QT4" "$q"
1588 cnf_append "PATH_TOOL_QT4" "$q"
1589 cnf_append "PATH_TOOL_QT4_BIN" "$q/bin"
1590 return
1591 fi
1592 fi
1593 done
1594 fi
1595 fi
1596 else
1597 log_failure "qt4 not working"
1598 fail
1599 fi
1600 else
1601 log_failure "qt4 not found"
1602 fail
1603 fi
1604}
1605
1606
1607#
1608# Check whether static libstdc++ is installed. This library is required
1609# for the Linux guest additions.
1610#
1611check_staticlibstdcxx()
1612{
1613 test_header "static stc++ library"
1614 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1615 cat > $ODIR.tmp_src.cc << EOF
1616#include <string>
1617
1618extern "C" int main(void)
1619{
1620 std::string s = "test";
1621 return 0;
1622}
1623EOF
1624 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1625 log_success "found"
1626 fi
1627}
1628
1629
1630#
1631# Check for Linux sources
1632#
1633check_linux()
1634{
1635 test_header "Linux kernel sources"
1636 cat > $ODIR.tmp_src.c << EOF
1637#include <linux/version.h>
1638int printf(const char *format, ...);
1639int main(void)
1640{
1641 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1642 (LINUX_VERSION_CODE % 65536) / 256,
1643 LINUX_VERSION_CODE % 256);
1644#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1645 printf(", OK.\n");
1646 return 0;
1647#else
1648 printf(", expected version 2.4.0 or higher\n");
1649 return 1;
1650#endif
1651}
1652EOF
1653 echo "compiling the following source file:" >> $LOG
1654 cat $ODIR.tmp_src.c >> $LOG
1655 echo "using the following command line:" >> $LOG
1656 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include" >> $LOG
1657 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include >> $LOG 2>&1
1658 if [ $? -ne 0 ]; then
1659 echo
1660 echo " Linux kernel headers not found at $LINUX"
1661 echo " Check the file $LOG for detailed error information."
1662 fail
1663 else
1664 if test_execute; then
1665 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1666 fi
1667 fi
1668}
1669
1670
1671#
1672# Check for kchmviewer, needed to display the online help
1673# (unused as we ship kchmviewer)
1674#
1675check_kchmviewer()
1676{
1677 test_header kchmviewer
1678 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1679 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1680 if [ $? -ne 0 ]; then
1681 log_failure "kchmviewer not working"
1682 fail
1683 else
1684 log_success "found version $kchmviewer_ver"
1685 fi
1686 fi
1687}
1688
1689
1690#
1691# Check for the kBuild tools, we don't support GNU make
1692#
1693check_kbuild()
1694{
1695 test_header kBuild
1696 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1697 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1698 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1699 echo "export PATH_KBUILD" >> $ENV
1700 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1701 echo "export PATH_DEVTOOLS" >> $ENV
1702 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1703 echo "export PATH_KBUILD_BIN" >> $ENV
1704 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1705 if [ "$OS" = "solaris" ]; then
1706 # Because of sh being non-default shell in Solaris we need to export PATH again when
1707 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1708 echo "PATH=\"$ORGPATH\"" >> $ENV
1709 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1710 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1711 else
1712 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1713 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1714 fi
1715 echo "export PATH" >> $ENV
1716 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1717 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1718 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1719 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1720 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1721 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1722 echo "export PATH_KBUILD" >> $ENV
1723 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1724 echo "export PATH_DEVTOOLS" >> $ENV
1725 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1726 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1727 echo "export PATH_KBUILD_BIN" >> $ENV
1728 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1729 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1730 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1731 echo "export PATH" >> $ENV
1732 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1733 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1734 elif check_avail "kmk" KBUILDDIR really; then
1735 # check for installed kBuild
1736 KBUILD_SED="`which_wrapper kmk_sed`"
1737 else
1738 fail
1739 fi
1740 log_success "found"
1741}
1742
1743
1744#
1745# Check for compiler.h
1746# Some Linux distributions include "compiler.h" in their libc linux
1747# headers package, some don't. Most don't need it, building might (!)
1748# not succeed on openSUSE without it.
1749#
1750# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1751#
1752check_compiler_h()
1753{
1754 test_header compiler.h
1755 if ! test -f "/usr/include/linux/compiler.h"; then
1756 log_success "compiler.h not found"
1757 else
1758 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1759 log_success "compiler.h found"
1760 fi
1761}
1762
1763#
1764# Check for libcap.
1765# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1766# sockets for doing ICMP requests.
1767#
1768check_libcap()
1769{
1770 test_header "libcap library"
1771 cat > $ODIR.tmp_src.cc << EOF
1772#include <cstdio>
1773#include <sys/types.h>
1774#include <sys/capability.h>
1775
1776extern "C" int main(void)
1777{
1778 char buf[1024];
1779 cap_t caps = cap_get_proc();
1780 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1781 return 0;
1782}
1783EOF
1784 if test_compile $LIBCAP libcap libcap; then
1785 if test_execute; then
1786 log_success "found"
1787 fi
1788 fi
1789}
1790
1791#
1792# Check if we are able to build 32-bit applications (needed for the guest additions)
1793#
1794check_32bit()
1795{
1796 test_header "32-bit support"
1797 cat > $ODIR.tmp_src.c << EOF
1798#include <stdint.h>
1799int main(void)
1800{
1801 return 0;
1802}
1803EOF
1804 echo "compiling the following source file:" >> $LOG
1805 cat $ODIR.tmp_src.c >> $LOG
1806 echo "using the following command line:" >> $LOG
1807 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1808 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1809 if [ $? -ne 0 ]; then
1810 echo
1811 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1812 echo " Check the file $LOG for detailed error information."
1813 fail
1814 else
1815 echo "executing the binary" >> $LOG
1816 $ODIR.tmp_out 2> $ODIR.test_execute.log
1817 rc=$?
1818 cat $ODIR.test_execute.log >> $LOG
1819 if [ $rc -ne 0 ]; then
1820 echo
1821 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
1822 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
1823 fail
1824 return 1
1825 fi
1826 fi
1827 log_success ""
1828}
1829
1830
1831#
1832# Check for Python
1833#
1834check_python()
1835{
1836 test_header "Python support"
1837
1838 # On darwin this is a on/off decision only
1839 if [ "$OS" = "darwin" ]; then
1840 echo "enabled"
1841 cnf_append "VBOX_WITH_PYTHON" "1"
1842 return
1843 fi
1844
1845 cat > $ODIR.tmp_src.cc << EOF
1846#include <cstdio>
1847#include <Python.h>
1848extern "C" int main(void)
1849{
1850 Py_Initialize();
1851 printf("found version %s", PY_VERSION);
1852#if PY_VERSION_HEX >= 0x02030000
1853 printf(", OK.\n");
1854 return 0;
1855#else
1856 printf(", expected version 2.3 or higher\n");
1857 return 1;
1858#endif
1859}
1860EOF
1861 found=
1862# For Solaris we use libpython2.4 for compatibility with Solaris 10 and passing IPS pkg audit
1863 if [ "$OS" != "solaris" ]; then
1864 SUPPYTHONLIBS="python2.7 python2.6 python2.5 python2.4 python2.3"
1865 else
1866 SUPPYTHONLIBS="python2.4"
1867 fi
1868 for p in $PYTHONDIR; do
1869 for d in $SUPPYTHONLIBS; do
1870 for b in lib64 lib/64 lib; do
1871 echo "compiling the following source file:" >> $LOG
1872 cat $ODIR.tmp_src.cc >> $LOG
1873 echo "using the following command line:" >> $LOG
1874 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1875 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1876 if [ $? -eq 0 ]; then
1877 found=1
1878 break
1879 fi
1880 done
1881 if [ -n "$found" ]; then break; fi
1882 done
1883 if [ -n "$found" ]; then break; fi
1884 done
1885 if [ -n "$found" ]; then
1886 if test_execute; then
1887 cnf_append "VBOX_WITH_PYTHON" "1"
1888 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
1889 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
1890 else
1891 log_failure "Python not working"
1892 fail
1893 fi
1894 else
1895 log_failure "Python not found"
1896 fail
1897 fi
1898}
1899
1900
1901#
1902# Check for Java
1903#
1904check_java()
1905{
1906 test_header "Java support"
1907 log_success
1908}
1909
1910
1911#
1912# Setup wine
1913#
1914setup_wine()
1915{
1916 test_header "Wine support"
1917 if ! which_wrapper wine > /dev/null; then
1918 echo " wine binary not found"
1919 fail
1920 fi
1921 if ! which_wrapper wineprefixcreate > /dev/null; then
1922 echo " wineprefixcreate not found"
1923 fail
1924 fi
1925 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
1926 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
1927 echo "export WINEPREFIX" >> $ENV
1928 rm -rf $WINEPREFIX
1929 mkdir -p $WINEPREFIX
1930 touch $WINEPREFIX/.no_prelaunch_window_flag
1931 if ! wineprefixcreate -q > /dev/null 2>&1; then
1932 echo " wineprefixcreate failed"
1933 fail
1934 fi
1935 tmp=.tmp.wine.reg
1936 rm -f $tmp
1937 echo 'REGEDIT4' > $tmp
1938 echo '' >> $tmp
1939 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
1940 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
1941 echo '' >> $tmp
1942 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
1943 echo '"itss"="native"' >> $tmp
1944 echo '' >> $tmp
1945 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
1946 echo '"itss"="native"' >> $tmp
1947 echo '' >> $tmp
1948 if ! wine regedit $tmp > /dev/null 2>&1; then
1949 rm -f $tmp
1950 echo " failed to load registry changes (path)."
1951 fail
1952 fi
1953 rm -f $tmp
1954 log_success "found"
1955}
1956
1957
1958#
1959# Check for gSOAP.
1960#
1961check_gsoap()
1962{
1963 test_header "GSOAP compiler"
1964 if [ -z "$GSOAP" ]; then
1965 GSOAP="/usr"
1966 fi
1967 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
1968 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
1969 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
1970 # TODO: Check for libgsoap++.a/so
1971
1972 if [ -z "$GSOAP_IMPORT" ]; then
1973 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
1974 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
1975 GSOAP_IMPORT="$GSOAP/include/gsoap"
1976 fi
1977 fi
1978 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
1979 cnf_append "VBOX_GSOAP_INSTALLED" "1"
1980 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
1981 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
1982 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
1983 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
1984 else
1985 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
1986 fi
1987 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoap++"
1988 log_success "found"
1989 else
1990 log_failure "stlvector.h not found -- disabling webservice"
1991 cnf_append "VBOX_WITH_WEBSERVICES" ""
1992 fi
1993 else
1994 log_failure "stdsoap2.h not found -- disabling webservice"
1995 cnf_append "VBOX_WITH_WEBSERVICES" ""
1996 fi
1997 else
1998 log_failure "wsdl2h not found -- disabling webservice"
1999 cnf_append "VBOX_WITH_WEBSERVICES" ""
2000 fi
2001 else
2002 log_failure "soapcpp2 not found -- disabling webservice"
2003 cnf_append "VBOX_WITH_WEBSERVICES" ""
2004 fi
2005}
2006
2007
2008#
2009# Determines the Darwin version.
2010# @todo This should really check the Xcode/SDK version.
2011#
2012check_darwinversion()
2013{
2014 test_header "Darwin version"
2015 darwin_ver=`uname -r`
2016 case "$darwin_ver" in
2017 10\.*)
2018 darwin_ver="10.6"
2019 if [ "$BUILD_MACHINE" = "x86" ]; then
2020 sdk=/Developer/SDKs/MacOSX10.5.sdk
2021 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2022 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2023 else
2024 sdk=/Developer/SDKs/MacOSX10.6.sdk
2025 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2026 fi
2027# test "$CC" = "gcc" && CC="gcc-4.0"
2028# test "$CXX" = "g++" && CXX="g++-4.0"
2029 ;;
2030 9\.*)
2031 darwin_ver="10.5"
2032 sdk=/Developer/SDKs/MacOSX10.5.sdk
2033 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2034# test "$CC" = "gcc" && CC="gcc-4.0"
2035# test "$CXX" = "g++" && CXX="g++-4.0"
2036 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2037 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2038 ;;
2039 8\.*)
2040 darwin_ver="10.4"
2041 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2042 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2043# test "$CC" = "gcc" && CC="gcc-4.0"
2044# test "$CXX" = "g++" && CXX="g++-4.0"
2045 cnf_append "VBOX_WITH_COCOA_QT" ""
2046 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2047 ;;
2048 *)
2049 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2050 fail
2051 darwin_ver="unknown"
2052 ;;
2053 esac
2054 log_success "found version $darwin_ver (SDK: $sdk)"
2055}
2056
2057
2058check_makeself()
2059{
2060 test_header "makeself"
2061 if check_avail "$MAKESELF" makeself; then
2062 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2063 if [ $? -ne 0 ]; then
2064 log_failure "makeself not working"
2065 fail
2066 else
2067 log_success "found version $makeself_ver"
2068 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2069 fi
2070 fi
2071}
2072
2073
2074#
2075# Checks that i386-elf-gcc-3.4.6, i386-elf-gcc-3.4.3, i386-elf-gcc-3.4 or i386-elf-gcc
2076# is around to prevent confusion when the build fails in src/recompiler.
2077# Note. Keep the which order in sync with the $(which ) in src/recompiler/Makefile.kmk.
2078#
2079check_i386elfgcc()
2080{
2081 test_header "i386-elf-gcc"
2082 i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.6`
2083 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4.3`
2084 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc-3.4`
2085 test -z "$i386_elf_gcc" && i386_elf_gcc=`which_wrapper i386-elf-gcc`
2086 if test -z "$i386_elf_gcc"; then
2087 echo " failed to find i386-elf-gcc"
2088 fail
2089 fi
2090 log_success "found $i386_elf_gcc"
2091}
2092
2093
2094#
2095# Show help
2096#
2097show_help()
2098{
2099cat << EOF
2100Usage: ./configure [OPTIONS]...
2101
2102Configuration:
2103 -h, --help display this help and exit
2104 --nofatal don't abort on errors
2105EOF
2106[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2107[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2108[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2109[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2110[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2111[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2112[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2113[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2114[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2115[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2116[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2117[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2118[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2119cat << EOF
2120 --disable-hardening don't be strict about /dev/vboxdrv access
2121 --build-libxml2 build libxml2 from sources
2122 --build-libxslt build libxslt from sources
2123EOF
2124[ $OSE -eq 0 ] && cat << EOF
2125 --build-libssl build openssl from sources
2126 --build-libcurl build libcurl from sources
2127EOF
2128[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2129cat << EOF
2130
2131Paths:
2132 --with-gcc=PATH location of the gcc compiler [$CC]
2133 --with-g++=PATH location of the g++ compiler [$CXX]
2134 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2135 --with-iasl=PATH location of the iasl compiler [$IASL]
2136 --with-mkisofs=PATH location of mkisofs [$MKISOFS]
2137EOF
2138[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2139[ $WITH_QT4 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt4 headers/libraries [pkgconfig]"
2140[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2141[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2142[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2143cat << EOF
2144 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2145 --out-path=PATH the folder to which configuration and build output
2146 should go
2147
2148Build type:
2149 -d, --build-debug build with debugging symbols and assertions
2150 --build-profile build with profiling support
2151 --build-headless build headless (without any GUI frontend)
2152EOF
2153 exit 0
2154}
2155
2156
2157#
2158# The body.
2159#
2160
2161# test if we are OSE
2162if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2163 OSE=0
2164 # Set this as a reminder to print a log message once we know the path of the
2165 # log file
2166 NOT_OSE=1
2167fi
2168
2169# Change OS specific defaults; must be before all other stuff
2170if [ "$OS" = "darwin" ]; then
2171 WITH_SDL=0
2172 WITH_SDL_TTF=0
2173 WITH_X11=0
2174 WITH_ALSA=0
2175 WITH_PULSE=0
2176 WITH_DBUS=0
2177 WITH_KMODS=0
2178 BUILD_LIBXSLT=1
2179 BUILD_LIBXML2=1
2180 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2181 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2182fi
2183
2184
2185# scan command line options
2186for option in $*; do
2187 case "$option" in
2188 --help|-help|-h)
2189 show_help
2190 ;;
2191 --nofatal)
2192 nofatal=1
2193 ;;
2194 --env-only)
2195 ENV_ONLY=1
2196 ;;
2197 --with-gcc=*)
2198 CC=`echo $option | cut -d'=' -f2`
2199 ;;
2200 --with-g++=*)
2201 CXX=`echo $option | cut -d'=' -f2`
2202 ;;
2203 --with-kbuild=*)
2204 KBUILDDIR=`echo $option | cut -d'=' -f2`
2205 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2206 echo "Error: KBUILDDIR contains invalid characters!"
2207 exit 1
2208 fi
2209 ;;
2210 --with-qt-dir=*|--with-qt4-dir=*)
2211 QT4DIR=`echo $option | cut -d'=' -f2`
2212 QT4DIR_PKGCONFIG=0
2213 ;;
2214 --with-openssl-dir=*)
2215 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2216 INCCRYPTO="-I${OPENSSLDIR}/include"
2217 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a"
2218 ;;
2219 --with-gsoap-dir=*)
2220 GSOAP=`echo $option | cut -d'=' -f2`
2221 ;;
2222 --with-gsoap-import=*)
2223 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2224 ;;
2225 --with-iasl=*)
2226 IASL=`echo $option | cut -d'=' -f2`
2227 ;;
2228 --with-linux=*)
2229 LINUX=`echo $option | cut -d'=' -f2`
2230 ;;
2231 --with-mkisofs=*)
2232 MKISOFS=`echo $option | cut -d'=' -f2`
2233 ;;
2234 --target-arch=*)
2235 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2236 ;;
2237 --disable-xpcom)
2238 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2239 ;;
2240 --disable-python)
2241 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2242 ;;
2243 --disable-java)
2244 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2245 ;;
2246 --disable-vmmraw)
2247 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2248 ;;
2249 --disable-sdl-ttf)
2250 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2251 ;;
2252 --disable-qt)
2253 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2254 ;;
2255 --disable-qt4)
2256 [ $WITH_QT4 -eq 1 ] && WITH_QT4=0
2257 ;;
2258 --passive-mesa)
2259 PASSIVE_MESA=1
2260 ;;
2261 --disable-alsa)
2262 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2263 ;;
2264 --disable-pulse)
2265 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2266 ;;
2267 --enable-pulse)
2268 WITH_PULSE=2
2269 ;;
2270 --disable-dbus)
2271 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2272 ;;
2273 --disable-kmods)
2274 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2275 ;;
2276 --disable-opengl)
2277 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2278 ;;
2279 --enable-webservice)
2280 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2281 ;;
2282 --disable-hardening)
2283 WITH_HARDENING=0
2284 ;;
2285 --disable-docs)
2286 WITH_DOCS=0
2287 ;;
2288 --enable-hardening)
2289 WITH_HARDENING=2
2290 ;;
2291 --enable-vde)
2292 WITH_VDE=1
2293 ;;
2294 --build-debug|-d)
2295 BUILD_TYPE=debug
2296 ;;
2297 --build-profile)
2298 BUILD_TYPE=profile
2299 ;;
2300 --build-libxml2)
2301 BUILD_LIBXML2=1
2302 ;;
2303 --build-libxslt)
2304 BUILD_LIBXSLT=1
2305 ;;
2306 --build-libssl)
2307 BUILD_LIBSSL=1
2308 ;;
2309 --build-libcurl)
2310 BUILD_LIBCURL=1
2311 ;;
2312 --build-headless)
2313 HEADLESS=1
2314 WITH_SDL=0
2315 WITH_SDL_TTF=0
2316 WITH_X11=0
2317 WITH_OPENGL=0
2318 WITH_QT4=0
2319 ;;
2320 --ose)
2321 OSE=2
2322 ;;
2323 --odir=*)
2324 ODIR="`echo $option | cut -d'=' -f2`/"
2325 ODIR_OVERRIDE=1
2326 ;;
2327 --out-path=*)
2328 out_path="`echo $option | cut -d'=' -f2`/"
2329 if [ -d $out_path ]; then
2330 saved_path="`pwd`"
2331 cd $out_path
2332 OUT_PATH="`pwd`"
2333 cd $saved_path
2334 OUT_PATH_OVERRIDE=1
2335 if [ $ODIR_OVERRIDE -eq 0 ]; then
2336 # This variable has not *yet* been overridden. That can still happen.
2337 ODIR=$OUT_PATH/
2338 fi
2339 else
2340 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2341 exit 1
2342 fi
2343 ;;
2344 --setup-wine)
2345 [ "$OS" != "darwin" ] && SETUP_WINE=1
2346 ;;
2347 *)
2348 echo
2349 echo "Unrecognized option \"$option\""
2350 echo
2351 show_help
2352 ;;
2353 esac
2354done
2355
2356LOG="$ODIR$LOG"
2357ENV="$ODIR$ENV"
2358CNF="$ODIR$CNF"
2359
2360# initialize output files
2361cat > $LOG << EOF
2362# Log file generated by
2363#
2364# '$0 $*'
2365#
2366
2367EOF
2368cat > $CNF << EOF
2369# -*- Makefile -*-
2370#
2371# automatically generated by
2372#
2373# '$0 $*'
2374#
2375# It will be completely overwritten if configure is executed again.
2376#
2377
2378EOF
2379cat > $ENV << EOF
2380#!/bin/bash
2381#
2382# automatically generated by
2383#
2384# '$0 $*'
2385#
2386# It will be completely overwritten if configure is executed again.
2387# Make sure you source this file once before you start to build VBox.
2388#
2389
2390EOF
2391
2392# Print log warning about OSE if necessary
2393if [ -n "$NOT_OSE" ]; then
2394 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2395 echo >> $LOG
2396fi
2397
2398
2399if [ "$BUILD_TYPE" = "debug" ]; then
2400 echo "Creating DEBUG build!" >> $LOG
2401elif [ "$BUILD_TYPE" = "profile" ]; then
2402 echo "Creating PROFILE build!" >> $LOG
2403fi
2404
2405# first determine our environment
2406check_environment
2407check_kbuild
2408
2409[ -n "$ENV_ONLY" ] && exit 0
2410
2411# append the tools directory to the default search path
2412echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2413export PATH
2414
2415# if we will be writing to a different out directory then set this up now
2416if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2417 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2418 echo "export AUTOCFG" >> $ENV
2419 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2420 echo "export LOCALCFG" >> $ENV
2421 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2422 echo "export PATH_OUT_BASE" >> $ENV
2423fi
2424
2425# some things are not available in for OSE
2426if [ $OSE -ge 1 ]; then
2427 cnf_append "VBOX_OSE" "1"
2428 cnf_append "VBOX_WITH_TESTSUITE" ""
2429 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2430
2431 if [ "$OS" = "linux" ]; then
2432 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2433 else
2434 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2435 fi
2436 echo >> $CNF
2437fi
2438
2439# headless
2440if [ -n "$HEADLESS" ]; then
2441 cnf_append "VBOX_HEADLESS" "1"
2442fi
2443
2444# emit disable directives corresponding to any --disable-xxx options.
2445if [ $WITH_OPENGL -eq 0 ]; then
2446 cnf_append "VBOX_WITH_CROGL" ""
2447 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2448 cnf_append "VBOX_GUI_USE_QGL" ""
2449fi
2450[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2451[ $WITH_QT4 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2452[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2453[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2454[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2455[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2456[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2457[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2458
2459# Darwin-specific
2460if [ "$OS" = "darwin" ]; then
2461 check_darwinversion
2462fi
2463# the tools
2464check_gcc
2465[ "$OS" != "darwin" ] && check_as86
2466[ "$OS" != "darwin" ] && check_bcc
2467[ "$OS" != "darwin" ] && check_iasl
2468# don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2469# [ "$OS" != "darwin" ] && check_yasm
2470[ "$OS" != "darwin" ] && check_xsltproc
2471[ "$OS" != "darwin" ] && check_mkisofs
2472
2473# the libraries
2474[ "$OS" != "darwin" ] && check_pthread
2475check_libxml2
2476[ $WITH_XPCOM -eq 1 ] && check_libxslt
2477[ $WITH_LIBIDL -eq 1 ] && check_libidl
2478check_ssl
2479check_curl
2480[ "$OS" != "darwin" ] && check_z
2481[ "$OS" != "darwin" ] && check_png
2482[ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2483[ $WITH_SDL -eq 1 ] && check_sdl
2484[ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2485[ $WITH_X11 -eq 1 ] && check_x
2486# TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2487# TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2488[ $WITH_X11 -eq 1 ] && check_xcursor
2489[ $WITH_X11 -eq 1 ] && check_xinerama
2490[ $WITH_X11 -eq 1 ] && check_xrandr
2491[ $WITH_OPENGL -eq 1 ] && check_opengl
2492[ $WITH_QT4 -eq 1 ] && check_qt4
2493[ $WITH_PYTHON -eq 1 ] && check_python
2494[ $WITH_JAVA -eq 1 ] && check_java
2495
2496# PulseAudio
2497if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2498 if [ $WITH_PULSE -eq 1 ]; then
2499 check_pulse
2500 elif [ $WITH_PULSE -eq 0 ]; then
2501 cnf_append "VBOX_WITH_PULSE" ""
2502 fi
2503fi
2504
2505# Linux-specific
2506if [ "$OS" = "linux" ]; then
2507 # don't check for the static libstdc++ in the PUEL version as we build the
2508 # additions at a dedicated box
2509 [ $OSE -ge 1 ] && check_staticlibstdcxx
2510 if [ $WITH_KMODS -eq 1 ]; then
2511 check_linux
2512 else
2513 cnf_append "VBOX_LINUX_SRC" ""
2514 cnf_append "VBOX_WITH_VBOXDRV" ""
2515 cnf_append "VBOX_WITH_ADDITION_DRIVERS" ""
2516 fi
2517 if [ $WITH_ALSA -eq 1 ]; then
2518 check_alsa
2519 else
2520 cnf_append "VBOX_WITH_ALSA" ""
2521 fi
2522 if [ $WITH_DBUS -eq 0 ]; then
2523 cnf_append "VBOX_WITH_DBUS" ""
2524 fi
2525 check_libcap
2526 check_compiler_h
2527 [ "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2528 # tools/common/makeself*
2529 [ $OSE -ge 1 ] && check_makeself
2530fi
2531
2532[ -n "$SETUP_WINE" ] && setup_wine
2533
2534if [ $OSE -ge 1 ]; then
2535 if [ $WITH_GSOAP -eq 1 ]; then
2536 check_gsoap
2537 else
2538 cnf_append "VBOX_WITH_WEBSERVICES" ""
2539 fi
2540fi
2541
2542# VDE
2543if [ "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2544 if [ $WITH_VDE -eq 1 ]; then
2545 cnf_append "VBOX_WITH_VDE" "1"
2546 fi
2547fi
2548
2549# DOCS
2550if [ $WITH_DOCS -eq 0 ]; then
2551 cnf_append "VBOX_WITH_DOCS" ""
2552 cnf_append "VBOX_WITH_DOCS_PACKING" ""
2553fi
2554
2555# success!
2556echo
2557echo "Successfully generated '$CNF' and '$ENV'."
2558echo "Source '$ENV' once before you start to build VBox:"
2559echo ""
2560echo " source $ENV"
2561echo " kmk"
2562echo ""
2563if [ "$OS" = "linux" ]; then
2564 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2565 vbox_out_path=$OUT_PATH
2566 else
2567 vbox_out_path=./out
2568 fi
2569 echo "To compile the kernel modules, do:"
2570 echo ""
2571 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2572 echo " make"
2573 echo ""
2574fi
2575if [ $WITH_HARDENING -gt 0 ]; then
2576 echo ""
2577 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2578 echo " Hardening is enabled which means that the VBox binaries will not run from"
2579 echo " the binary directory. The binaries have to be installed suid root and some"
2580 echo " more prerequisites have to be fulfilled which is normally done by installing"
2581 echo " the final package. For development, the hardening feature can be disabled"
2582 echo " by specifying the --disable-hardening parameter. Please never disable that"
2583 echo " feature for the final distribution!"
2584 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2585 echo ""
2586else
2587 echo ""
2588 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2589 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2590 echo " disabled hardening!"
2591 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2592 echo ""
2593fi
2594echo "Enjoy!"
2595cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use